﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TextMarksV2APIClient_DotNet;
using Newtonsoft.Json.Linq;

namespace ExampleUsage
{
    public class ExampleUsage
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="args"></param>
        static void Main(string[] args)
        {
            try
            {
                TextMarksV2APIClient tmapi = null;
                Dictionary<string, object> msoParams = null;
                JObject joResp = null;

                // Most basic echo test:
                Console.WriteLine("Echo test...");
                tmapi = new TextMarksV2APIClient();
                msoParams = new Dictionary<string, object>();
                msoParams.Add("str", "Hello World");
                joResp = tmapi.Call("Test", "echo", msoParams);

                // Check a keyword status:
                Console.WriteLine("Keyword status test...");
                tmapi = new TextMarksV2APIClient();
                msoParams = new Dictionary<string, object>();
                tmapi.SetApiKey("MyAPIKEY_12345678");
                msoParams.Add("keyword", "MYKEYWORD");
                joResp = tmapi.Call("Anybody", "keyword_status", msoParams);
                Console.WriteLine("Keyword Status Code: " + joResp["body"]["status"]);

                // Invite a user to join a TextMark group:
                Console.WriteLine("Invite a user to join a TextMark group test...");
                tmapi = new TextMarksV2APIClient();
                msoParams = new Dictionary<string, object>();
                tmapi.SetApiKey("MyAPIKEY_12345678");
                msoParams.Add("tm", "MYKEYWORD");
                msoParams.Add("user", "4155551212");
                joResp = tmapi.Call("Anybody", "invite_to_group", msoParams);
                Console.WriteLine("Done.");

                // Broadcast a message to a TextMark group:
                Console.WriteLine("Broadcasting a message to a TextMark group test...");
                tmapi = new TextMarksV2APIClient();
                msoParams = new Dictionary<string, object>();
                tmapi.SetApiKey("MyAPIKEY_12345678");
                tmapi.SetAuthUser("mytmuser"); // (or my TextMarks phone#)
                tmapi.SetAuthPass("mytmp@word");
                msoParams.Add("tm", "MYKEYWORD");
                msoParams.Add("msg", "This is an alert sent from the Java API Client. Did it work?");
                joResp = tmapi.Call("GroupLeader", "broadcast_message", msoParams);
                Console.ReadKey();
            }
            catch (TextMarksV2APIClientException ex)
            {
                Console.ReadKey();
                Console.WriteLine("Whoops... Exception caught!");
                Console.WriteLine("Error code: " + ex.GetCode());
                Console.WriteLine("Exception: " + ex.Message);
            }
            catch (Exception ex)
            {
                Console.ReadKey();
                Console.WriteLine("Exception: " + ex.Message);
            }
        }
    }
}
